﻿Public Class Measurement

    ''' <summary>
    ''' lineLength
    ''' </summary>
    ''' <param name="p1">point1</param>
    ''' <param name="p2">point2</param>
    ''' <returns>length in pixels between p1 and p2</returns>
    ''' <remarks></remarks>
    Public Shared Function lineLength(ByVal p1 As Point, ByVal p2 As Point) As Integer
        Return CInt(Math.Sqrt(Math.Abs(p1.X - p2.X) ^ 2 + Math.Abs(p1.Y - p2.Y) ^ 2))
    End Function

    ''' <summary>
    ''' returns degrees in this coordinate system:
    ''' N,E,S,W = 0,90,180,270 degrees
    ''' </summary>
    ''' <param name="p1">point1</param>
    ''' <param name="p2">point2</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function FindAngle(ByVal p1 As Point, ByVal p2 As Point) As Integer
        Dim atn1 As Double = Math.Atan(1)
        Dim dx As Double = p2.X - p1.X
        Dim dy As Double = p2.Y - p1.Y

        'Avoid divide by 0 error
        If (dx = 0) Then dx = 1.0E-20
        'Find arctangent and (orient to 12 o'clock)
        Dim angle As Double = Math.Atan(dy / dx) + (atn1 * 2)
        'Adjust for quadrant
        If (p2.X < p1.X) Then angle = angle + (atn1 * 4)

        Return CInt(angle * 45 / atn1)

    End Function

End Class
